#ifndef ARGSET_NCREF_HH
#define ARGSET_NCREF_HH

#include "paramlists.hh"
#include "refholder.hh"
#include "ctif.hh"
#include "argset_contains.hh"

namespace ArgSets
{
    struct NCRefEndOfList
    {};

    template<unsigned pos_,typename Next_>
    struct NCRefPosEntry
    {
	static const unsigned pos=pos_;
	typedef Next_ Next;
    };

    template<typename ArgSet,unsigned index,unsigned argCount>
    struct NCArgList
    {
	typedef typename NCArgList<ArgSet,index+1,argCount>::Type NextEntry;
	typedef typename CT::If<ArgSets::ArgSetContains<ArgSet,
							Holder::RefHolder<FuncImpl::ParamType<index> > >::result,
				NCRefPosEntry<index,NextEntry>,
				NextEntry>::Type Type;
    };

    template<typename ArgSet,unsigned argCount>
    struct NCArgList<ArgSet,argCount,argCount>
    {
	typedef NCRefEndOfList NextEntry;
	typedef typename CT::If<ArgSets::ArgSetContains<ArgSet,
							Holder::RefHolder<FuncImpl::ParamType<argCount> > >::result,
				NCRefPosEntry<argCount,NextEntry>,
				NextEntry>::Type Type;
    };

    template<typename ArgSet,unsigned index>
    struct NCArgList<ArgSet,index,0>
    {
	typedef NCRefEndOfList Type;
    };
    

    template<typename ArgSet>
    struct FindNonConstArgs
    {
	typedef typename NCArgList<ArgSet,1,ArgSets::MinArgs<ArgSet>::result>::Type Type;
    };
}

#endif
