#include <cassert>
#include <memory>
#include "compose_memfun.hh"


struct X
{
    int i;
    int f()
    {
	return i;
    }
    int g(int j)
    {
	return i*j;
    }
    int fc() const
    {
	return i;
    }
    int gc(int j) const
    {
	return i*j;
    }
    
};

struct Y:
    X
{
    Y()
    {
	i=2;
    }
};



int main()
{
    X x=
	{
	    1
	};

    Y y;

    std::auto_ptr<X> xp(new X);
    xp->i=3;
    
    std::auto_ptr<Y> yp(new Y);

    // non-const mem fun
    assert(Compose::compose(&X::f,Compose::byRef(_1))(x)==1);
    assert(Compose::compose(&X::f,_1)(&x)==1);
    assert(Compose::compose(&X::f,Compose::byRef(_1))(y)==2);
    assert(Compose::compose(&X::f,_1)(&y)==2);
    assert(Compose::compose(&X::f,_1)(xp)==3);
    assert(Compose::compose(&X::f,_1)(yp)==2);

    assert(Compose::compose(&X::g,_2,_1)(4,xp)==12);

    const X x2=x;
    const Y y2=y;

    std::auto_ptr<const X> xp2(new X(*xp));
    std::auto_ptr<const Y> yp2(new Y(*yp));

    // const mem fun
    assert(Compose::compose(&X::fc,Compose::byRef(_1))(x2)==1);
    assert(Compose::compose(&X::fc,_1)(&x2)==1);
    assert(Compose::compose(&X::fc,Compose::byRef(_1))(y2)==2);
    assert(Compose::compose(&X::fc,_1)(&y2)==2);
    assert(Compose::compose(&X::fc,_1)(xp2)==3);
    assert(Compose::compose(&X::fc,_1)(yp2)==2);

    assert(Compose::compose(&X::gc,_2,_1)(4,xp2)==12);

    // const mem fun, non-const obj
    assert(Compose::compose(&X::fc,Compose::byRef(_1))(x)==1);
    assert(Compose::compose(&X::fc,_1)(&x)==1);
    assert(Compose::compose(&X::fc,Compose::byRef(_1))(y)==2);
    assert(Compose::compose(&X::fc,_1)(&y)==2);
    assert(Compose::compose(&X::fc,_1)(xp)==3);
    assert(Compose::compose(&X::fc,_1)(yp)==2);

    assert(Compose::compose(&X::gc,_2,_1)(4,xp)==12);
}
