#ifndef VOID_RETURN_HH
#define VOID_RETURN_HH

#include "exprtype.hh"

namespace FuncImpl
{
    struct Void
    {};

    template<typename Func>
    class VoidWrapper
    {
    public:
	VoidWrapper(const Func& func_):
	    func(func_)
	{}

	Void operator()() const
	{
	    func();
	    return Void();
	}
	template<typename A1>
	Void operator()(const A1& a1) const
	{
	    func(a1);
	    return Void();
	}
	template<typename A1,typename A2>
	Void operator()(const A1& a1,const A2& a2) const
	{
	    func(a1,a2);
	    return Void();
	}
	template<typename A1,typename A2,typename A3>
	Void operator()(const A1& a1,const A2& a2,const A3& a3) const
	{
	    func(a1,a2,a3);
	    return Void();
	}
	template<typename A1,typename A2,typename A3,typename A4>
	Void operator()(const A1& a1,const A2& a2,const A3& a3,const A4& a4) const
	{
	    func(a1,a2,a3,a4);
	    return Void();
	}
	template<typename A1,typename A2,typename A3,typename A4,typename A5>
	Void operator()(const A1& a1,const A2& a2,const A3& a3,const A4& a4,const A5& a5) const
	{
	    func(a1,a2,a3,a4,a5);
	    return Void();
	}
	template<typename A1,typename A2,typename A3,typename A4,typename A5,
		 typename A6>
	Void operator()(const A1& a1,const A2& a2,const A3& a3,const A4& a4,const A5& a5,
			const A6& a6) const
	{
	    func(a1,a2,a3,a4,a5,a6);
	    return Void();
	}
	template<typename A1,typename A2,typename A3,typename A4,typename A5,
		 typename A6,typename A7>
	Void operator()(const A1& a1,const A2& a2,const A3& a3,const A4& a4,const A5& a5,
			const A6& a6,const A7& a7) const
	{
	    func(a1,a2,a3,a4,a5,a6,a7);
	    return Void();
	}
	template<typename A1,typename A2,typename A3,typename A4,typename A5,
		 typename A6,typename A7,typename A8>
	Void operator()(const A1& a1,const A2& a2,const A3& a3,const A4& a4,const A5& a5,
			const A6& a6,const A7& a7,const A8& a8) const
	{
	    func(a1,a2,a3,a4,a5,a6,a7,a8);
	    return Void();
	}
	template<typename A1,typename A2,typename A3,typename A4,typename A5,
		 typename A6,typename A7,typename A8,typename A9>
	Void operator()(const A1& a1,const A2& a2,const A3& a3,const A4& a4,const A5& a5,
			const A6& a6,const A7& a7,const A8& a8,const A9& a9) const
	{
	    func(a1,a2,a3,a4,a5,a6,a7,a8,a9);
	    return Void();
	}
	template<typename A1,typename A2,typename A3,typename A4,typename A5,
		 typename A6,typename A7,typename A8,typename A9,typename A10>
	Void operator()(const A1& a1,const A2& a2,const A3& a3,const A4& a4,const A5& a5,
			const A6& a6,const A7& a7,const A8& a8,const A9& a9,const A10& a10) const
	{
	    func(a1,a2,a3,a4,a5,a6,a7,a8,a9,a10);
	    return Void();
	}
    
    private:
	Func func;
    };
}
namespace Compose
{
    template<typename Func>
    FuncImpl::VoidWrapper<Func> voidReturn(const Func& func)
    {
	return func;
    }
    
}

REGISTER_EXPR_TYPE(FuncImpl::Void,29)


#endif
